<script setup lang="ts">
import { usePromotionStore } from '@/stores/promotion';
import { onMounted, ref, computed } from 'vue';
import PromotionDialog from './PromotionDialog.vue';
import type Promotion from '@/types/Promotion';
const backendURL = import.meta.env.VITE_BACKEND_URL;
const promotionStore = usePromotionStore();
const selectedPromotion = ref<Promotion | null>(null);
const editPromotion = (promotion: Promotion) => {
    promotionStore.editPromotion(promotion);
};

const deletePromotion= (promotionId: number) => {
    promotionStore.deletePromotion(promotionId);
};
const selectPromotion= (promotion: Promotion) => {
    selectedPromotion.value = promotion;
};

const isSelected = (promotion: Promotion) => {
    return selectedPromotion.value !== null && selectedPromotion.value.id === promotion.id;
};
const formatDate = (endDate: string) => {
    const date = new Date(endDate);
    const day = date.getDate().toString().padStart(2, '0'); // Add leading zero if single digit
    const monthNamesThai = [
        "ม.ค.", "ก.พ.", "มี.ค.", "เม.ย.", "พ.ค.", "มิ.ย.",
        "ก.ค.", "ส.ค.", "ก.ย.", "ต.ค.", "พ.ย.", "ธ.ค."
    ];
    const month = monthNamesThai[date.getMonth()]; // Get Thai month name
    const year = date.getFullYear().toString().slice(-2); // Get last two digits of the year
    return `${day} ${month} ${year}`;
};

onMounted(() => {
    promotionStore.getPromotion();
});
</script>
<template>
    <PromotionDialog></PromotionDialog>
    <v-card theme="light" height="919" outlined="false">

        <v-row class="mt-5">
            <v-col cols="5"><span class="fontTitle ml-14">โปรโมชัน</span></v-col>
            <v-col></v-col>
            <v-col cols="2">
                <v-btn class="font">ชื่อผู้ใช้ : บีมเองจ้า</v-btn>
            </v-col>
        </v-row>
        <v-row class="mt-2">
            <v-col></v-col>
            <v-col>
                <v-card theme="light" height="700" width="1800" style="border: 1px solid rgba(0, 0, 0, 0.1);">

                    <v-row>
                        <v-col cols="4" v-for="item of promotionStore.promotions" :key="item.id" >
                            <v-card class="ma-5" width="500px" height="200px"
                                style="border-radius: 18px; border: 1px solid rgba(0, 0, 0, 0.1);"
                                @click="selectPromotion(item)"
                            :style="{ backgroundColor: isSelected(item) ? '#c2c2c2' : 'inherit' }">

                                <v-row class="ma-2">
                                    <v-col cols="2"></v-col>
                                    <v-col cols="7"><span class="fontcardtitle">{{ item.name }}</span></v-col>
                                    <v-col><v-icon icon="mdi-sale-outline" size="80px"></v-icon></v-col>
                                </v-row>
                                <v-row>
                                    <v-col cols="1"></v-col>
                                    <v-col cols="7"><span class="fontcard">{{ item.description }}</span></v-col>
                                    <v-col><span class="ml-8 fontdate">ใช้ได้ถึง {{ formatDate(item.endDate.toString())
                                    }}</span></v-col>

                                </v-row>
                            </v-card>
                        </v-col>
                    </v-row>


                </v-card>
            </v-col>
            <v-col></v-col>
        </v-row>
        <v-row>
            <v-col cols="3" class="ml-13 mt-4">
                <v-btn to="/management" class="font">ย้อนกลับ</v-btn>
                <v-btn to="/" class="font ml-5">กลับหน้าหลัก</v-btn>
            </v-col>
            <v-col cols="6">
            </v-col>
            <v-col cols="">
                <v-btn class="font ml-5" @click="promotionStore.dialog = true">เพิ่ม</v-btn>
                <!-- <v-btn class="font ml-5">แก้ไข</v-btn>
                <v-btn class="font ml-5">ลบ</v-btn> -->
                <v-btn v-if="!selectedPromotion" class="font ml-5">แก้ไข</v-btn>
                <v-btn v-else class="font ml-5" @click="editPromotion(selectedPromotion)">แก้ไข</v-btn>
                <v-btn v-if="!selectedPromotion" class="font ml-5">ลบ</v-btn>
                <v-btn v-else class="font ml-5" @click="deletePromotion(selectedPromotion.id!)">ลบ</v-btn>
            </v-col>
        </v-row>
    </v-card>
</template>
<style scoped>
.fontTitle {
    text-align-last: center;
    font-family: fantasy;
    font-size: 35px;
    color: black;
}

.font {
    text-align-last: center;
    font-family: fantasy;
    font-size: 18px;
    color: black;
}

.fontcardtitle {
    text-align-last: center;
    font-family: fantasy;
    font-size: 25px;
    color: black;
}

.fontcard {
    text-align-last: center;
    font-family: fantasy;
    font-size: 18px;
    color: black;
}

.fontdate {
    text-align-last: center;
    font-family: fantasy;
    font-size: 14px;
    color: black;
}
</style>